diff --git a/Units/parser-fortran.r/common-json.f.d/expected.tags-json b/Units/parser-fortran.r/common-json.f.d/expected.tags-json
new file mode 100644
index 0000000000..7fc9b3dbe0
--- /dev/null
+++ b/Units/parser-fortran.r/common-json.f.d/expected.tags-json
@@ -0,0 +1,4 @@
+{"_type": "tag", "name": "common1", "path": "input.f", "pattern": "/^        COMMON \\/common1\\//", "kind": "common", "scope": "main", "scopeKind": "program"}
+{"_type": "tag", "name": "common2", "path": "input.f", "pattern": "/^        COMMON \\/common2\\//", "kind": "common", "scope": "main", "scopeKind": "program"}
+{"_type": "tag", "name": "common3", "path": "input.f", "pattern": "/^        COMMON \\/common2\\/ c2a (1:3), c2b \\/common3\\//", "kind": "common", "scope": "main", "scopeKind": "program"}
+{"_type": "tag", "name": "main", "path": "input.f", "pattern": "/^        PROGRAM main$/", "kind": "program"}
diff --git a/Units/parser-fortran.r/common-json.f.d/input.f b/Units/parser-fortran.r/common-json.f.d/input.f
new file mode 100644
index 0000000000..c92aa45565
--- /dev/null
+++ b/Units/parser-fortran.r/common-json.f.d/input.f
@@ -0,0 +1,4 @@
+        PROGRAM main
+        COMMON /common1/ c1a, c1b
+        COMMON /common2/ c2a (1:3), c2b /common3/ c3a, c3b
+        END
diff --git a/Units/parser-fortran.r/common-xref.f.d/args.ctags b/Units/parser-fortran.r/common-xref.f.d/args.ctags
new file mode 100644
index 0000000000..d02c0d22ca
--- /dev/null
+++ b/Units/parser-fortran.r/common-xref.f.d/args.ctags
@@ -0,0 +1 @@
+--_xformat=%-16N %-10K %4n %-16F %P
diff --git a/Units/parser-fortran.r/common-xref.f.d/expected.tags-x b/Units/parser-fortran.r/common-xref.f.d/expected.tags-x
new file mode 100644
index 0000000000..b29b3fbd32
--- /dev/null
+++ b/Units/parser-fortran.r/common-xref.f.d/expected.tags-x
@@ -0,0 +1,4 @@
+common1          common        2 input.f /^        COMMON \/common1\//
+common2          common        3 input.f /^        COMMON \/common2\//
+common3          common        3 input.f /^        COMMON \/common2\/ c2a (1:3), c2b \/common3\//
+main             program       1 input.f /^        PROGRAM main$/
diff --git a/Units/parser-fortran.r/common-xref.f.d/input.f b/Units/parser-fortran.r/common-xref.f.d/input.f
new file mode 100644
index 0000000000..c92aa45565
--- /dev/null
+++ b/Units/parser-fortran.r/common-xref.f.d/input.f
@@ -0,0 +1,4 @@
+        PROGRAM main
+        COMMON /common1/ c1a, c1b
+        COMMON /common2/ c2a (1:3), c2b /common3/ c3a, c3b
+        END
diff --git a/main/field.c b/main/field.c
index 0b2f2e65ca..b1b42a8f3d 100644
--- a/main/field.c
+++ b/main/field.c
@@ -56,7 +56,8 @@ static const char *renderFieldAccess (const tagEntryInfo *const tag, const char
 static const char *renderFieldKindLetter (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
 static const char *renderFieldImplementation (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
 static const char *renderFieldFile (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
-static const char *renderFieldPattern (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
+static const char *renderFieldPatternCommon (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
+static const char *renderFieldPatternCtags (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
 static const char *renderFieldRole (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
 static const char *renderFieldRefMarker (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
 static const char *renderFieldExtras (const tagEntryInfo *const tag, const char *value, vString* b, bool *rejected);
@@ -111,7 +112,10 @@ static fieldDefinition fieldDefinitionsFixed [] = {
 	DEFINE_FIELD ('P', "pattern",  true,
 			   "pattern",
 			   FIELDTYPE_STRING,
-			   [WRITER_U_CTAGS] = renderFieldPattern),
+			   [WRITER_U_CTAGS] = renderFieldPatternCtags,
+			   [WRITER_XREF]    = renderFieldPatternCommon,
+			   [WRITER_JSON]    = renderFieldPatternCommon,
+		),
 };
 
 static fieldDefinition fieldDefinitionsExuberant [] = {
@@ -681,14 +685,11 @@ static const char *renderFieldFile (const tagEntryInfo *const tag,
 	return renderAsIs (b, tag->isFileScope? "file": "-");
 }
 
-static const char *renderFieldPattern (const tagEntryInfo *const tag,
+static const char *renderFieldPatternCommon (const tagEntryInfo *const tag,
 				       const char *value CTAGS_ATTR_UNUSED,
 				       vString* b,
 					   bool *rejected CTAGS_ATTR_UNUSED)
 {
-	if (tag->lineNumberEntry)
-		return NULL;
-
 	if (tag->pattern)
 		vStringCatS (b, tag->pattern);
 	else
@@ -702,6 +703,22 @@ static const char *renderFieldPattern (const tagEntryInfo *const tag,
 	return vStringValue (b);
 }
 
+static const char *renderFieldPatternCtags (const tagEntryInfo *const tag,
+				       const char *value,
+				       vString* b,
+					   bool *rejected)
+{
+	/* This is for handling 'common' of 'fortran'.  See the
+	   description of --excmd=mixed in ctags.1.  In tags output, what
+	   we call "pattern" is instructions for vi.
+
+	   However, in the other formats, pattern should be pattern as its name. */
+	if (tag->lineNumberEntry)
+		return NULL;
+
+	return renderFieldPatternCommon(tag, value, b, rejected);
+}
+
 static const char *renderFieldRefMarker (const tagEntryInfo *const tag,
 					 const char *value CTAGS_ATTR_UNUSED,
 					 vString* b,
